#baseDir<-"../../PhD/_paper_XyDye/imageAnalysis_supplement";source(paste0(baseDir,"/step1_computeNDBI.r"))

# computes ndbi values for each cut surface image

# requires:
#  config.r (measurementFile)
#  images/01_photos/xx.jpg

# creates:
#  images/03_NDBI/xx.png

library("readbitmap")
library("png")

if(!exists("baseDir")) baseDir <- getwd()
source(paste0(baseDir,"/config.r"))
experimentInfo <- read.table(paste0(baseDir,'/',config.measurementFile), sep='\t', header=TRUE)


for(n in 1:nrow(experimentInfo)){
	pic <- read.bitmap(paste0(baseDir,"/images/01_photos/",experimentInfo$SegmentID[n],".jpg"))	
	y <- dim(pic)[1]
	
	cat("analyze pic#",n,'\n')
	b <- pic[,,3] # blue pixel values
	g <- pic[,,2] # green pixel values
	r <- pic[,,1] # red pixel values
	
	# compute NDBI as difference of 
	#   blue to red normalized by sum of blue and red
	ndbi <- (b-r)/(b+r)	
	#ndbi <- (b-(r+g)/2)/(b+(r+g)/2)
		
	png(paste0(baseDir,"/images/03_NDBI/",experimentInfo$SegmentID[n],".png"), width=ncol(pic), height=nrow(pic), bg = "transparent")
		par(mar=c(0,0,0,0))
		plot.new()
		
		# ndbi values can range from -1 to 1,
		# but for the raster output we have to rescale them to a range between 0 and 1
		outVal <- (ndbi+1)/2

		rasterImage(outVal,-0.04,-0.04,1.04,1.04, xaxs='i', yaxs='i')	
	dev.off()
}

